var AceTemplate = AceTemplate || {};

(function(){
	/**
	 * Ace Engine Template
	 * һ׻HTMLJS﷨ɴģϵͳ
	 * http://code.google.com/p/ace-engine/wiki/AceTemplate
	 * @author (wangjihuhttp://weibo.com/zswang) ³Ȼ(luyaranhttp://weibo.com/zinkey)
	 * @version 2011-07-06 
 	 * @copyright (c) 2011, Baidu Inc, All rights reserved.
	 */

	/* Debug Start */
	var logger = {
		/**
		 * ӡ־
		 * @param {Object} text ־ı
		 */
		log: function(text) {
			/*
			var dom = document.getElementById("log");
			if (dom) {
				dom.value += text + "\n";
			}
			*/
			window.console && console.log(text)
		}
	};
	/* Debug End */
	
	var htmlDecodeDict = { "quot": '"', "lt": "<", "gt": ">", "amp": "&", "nbsp": " " };
	var htmlEncodeDict = { '"': "quot", "<": "lt", ">": "gt", "&": "amp", " ": "nbsp" };
	var lib = {
		/**
		 * ͨidDOM
		 * @param {String} id
		 */
		g: function(id){
			if (typeof id != "string") 
				return id;
			return document.getElementById(id);
		},
		/**
		 * HTML
		 * @param {String} html
		 */
		decodeHTML: function(html) {
			return String(html).replace(/&(quot|lt|gt|amp|nbsp);/ig, function(all, key) {
				return htmlDecodeDict[key];
			}).replace(/&#u([a-f\d]{4});/ig, function(all, hex) {
				return String.fromCharCode(parseInt("0x" + hex));
			}).replace(/&#(\d+);/ig, function(all, number) {
				return String.fromCharCode(+number);
			});
		},
		
		/**
		 * HTML
		 * @param {String} html 
		 */
		encodeHTML: function(html) {
			return String(html).replace(/["<>& ]/g, function(all) {
				return "&" + htmlEncodeDict[all] + ";";
			});
		},
		/**
		 * Ԫı
		 * @param {Element} element
		 */
		elementText: function(element) {
			if (!element || !element.tagName) return "";
			if (/^(input|textarea)$/i.test(element.tagName))
				return element.value;
			return lib.decodeHTML(element.innerHTML);
		}
	};
	
	/**
	 * 
	 */
	var readerCaches = {};
	
	/**
	 * Ƿעģ
	 */
	var registerAll = false;

	/**
	 * ģĴ
	 * JSĹ
	 * 	ַͷ
	 * 		ʾ֡#{value}<div>
	 * 		/^\s*[<>!#^&\u0000-\u0008\u007F-\uffff].*$/mg
	 * 	htmlǽ磺
	 * 		ʾ>src="1.gif" />
	 * 		/^.*[<>]\s*$/mg
	 * 	ûС˫ššֺšţСšelseȵ䡢磺
	 * 		ʾhello world
	 * 		/^(?!\s*(else|do|try|finally)\s*$)[^'":;,\[\]{}()\n\/]+$/mg
	 * 	Աʽ
	 * 		ʾa="12" b="45"a='ab' b="cd"
	 * 		/^(\s*(([\w-]+\s*=\s*"[^"]*")|([\w-]+\s*=\s*'[^']*')))+\s*$/mg
	 * 	ʽʽ
	 * 		ʾdiv.focus{color: #fff;}#btnAdd span{}
	 * 		/^\s*([.#][\w-.]+(:\w+)?(\s*|,))*(?!(else|do|while|try|return)\b)[.#]?[\w-.*]+(:\w+)?\s*\{.*$/mg
	 * @param {String} template ģַ
	 */
	function analyse(template) {
		var body = [], processItem = [];
		body.push("with(this){");
		body.push(template
			.replace(/[\r\n]+/g, "\n") // ȥĻУȥIE˵\r
			.replace(/^\n+|\s+$/mg, "") // ȥУײУβհ
			.replace(/((^\s*[<>!#^&\u0000-\u0008\u007F-\uffff].*$|^.*[<>]\s*$|^(?!\s*(else|do|try|finally)\s*$)[^'":;,\[\]{}()\n\/]+$|^(\s*(([\w-]+\s*=\s*"[^"]*")|([\w-]+\s*=\s*'[^']*')))+\s*$|^\s*([.#][\w-.]+(:\w+)?(\s*|,))*(?!(else|do|while|try|return)\b)[.#]?[\w-.*]+(:\w+)?\s*\{.*$)\s?)+/mg, function(expression) { // ԭ
				expression = ['"', expression
					.replace(/&none;/g, "") // ַ
					.replace(/["'\\]/g, "\\$&") // ת
					.replace(/\n/g, "\\n") // سת
					.replace(/(!?#)\{(.*?)\}/g, function (all, flag, template) { // 滻
						template = template.replace(/\\n/g, "\n").replace(/\\([\\'"])/g, "$1"); // ԭת
						var identifier = /^[a-z$][\w+$]+$/i.test(template) &&
							!(/^(true|false|NaN|null|this)$/.test(template)); // һδ屣
						return ['",', 
							identifier ? ['typeof ', template, '=="undefined"?"":'].join("") : "", 
							(flag == "#" ? '_encode_' : ""), 
							'(', template, '),"'].join("");
					}), '"'].join("").replace(/^"",|,""$/g, "");
				if (expression)	
					return ['_output_.push(', expression, ');'].join("");
				else return "";
			}));
		body.push("}");
		var result = new Function("_output_", "_encode_", "helper", body.join(""));
		/* Debug Start */
		logger.log(String(result));
		/* Debug End */
		return result;
	}

	/**
	 * ʽ
	 * @param {String|Element} id ģIDģ屾(ǱʶʶΪģ屾)
	 * @param {Object} data ʽݣĬΪַ
	 * @param {Object} helper (ĬΪģ)
	 */
	AceTemplate.format = function(id, data, helper) {
		if (!id) return "";
		var reader, element;
		if (typeof id == "object" && id.tagName) { // Dom
			element = id;
			id = element.getAttribute("id");
		}
		helper = helper || this; // Ĭϸ
		reader = readerCaches[id]; // ȶȡ
		if (!reader) { // δ
			if (!/[^\w-]/.test(id)) { // Ϸıʶidȡ
				if (!element) {
					element = lib.g(id);
				}
				reader = this.register(id, element);
			} else {
				reader = analyse(id);
			}
		}
		var output = [];
		reader.call(data || "", output, lib.encodeHTML, helper);
		return output.join("");
	};
	
	/**
	 * עģ壬ûвעscriptǩģ
	 * @param {String} id ģID
	 * @param {Element|String} target ģģַûĬϻȡidӦDOM
	 */
	AceTemplate.register = function(id, target) {
		if (!arguments.length && !registerAll) { // ޲ûע
			registerAll = true;
			var scripts = document.getElementsByTagName("script");
			for (var i = 0; i < scripts.length; i++) {
				var script = scripts[i];
				if (/^(text\/template)$/i.test(script.getAttribute("type"))) {
					var id = script.getAttribute("id");
					id && arguments.callee.call(this, id, script);
				}
			}
		}
		if (!id) return;
		if (readerCaches[id]) { // Ѿע
			return readerCaches[id];
		}
		if (typeof target != "string") {
			if (typeof target == "undefined") {
				target = lib.g(id);
			}
			target = lib.elementText(target);
		}
		return readerCaches[id] = analyse(target);
	};
	
	/**
	 * עģ
	 * @param {String} id ģID
	 */
	AceTemplate.unregister = function(id) {
		delete readerCaches[id];
	};
})();